/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mobileapplication2;

import java.util.Vector;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.TextField;
import javax.microedition.midlet.*;

/**
 * @author andres
 */
public class Midlet extends MIDlet implements CommandListener {

    private Display display;
    private Form form;
    private TextField notaTextField;
    private TextField maxTextField;
    private TextField minTextField;
    private TextField promedioTextField;
    private TextField aprobadosTextField;
    private TextField reprobadosTextField;

    private Command cancelar;
    private Command agregar;
    private Command calcular;
    private Vector notas;

    private final static String CANCELAR = "Cancelar";
    private final static String AGREGAR = "Agregar";
    private final static String CALCULAR = "Calcular";
    private final static String VACIA = "";

    private static float REPROBATORIA = 6f;

    public Midlet() {


        notas = new Vector();

    }

    public void startApp() {

                form = new Form("Notas");

        notaTextField = new TextField("Nota:", VACIA, 10, TextField.DECIMAL);
        maxTextField = new TextField("Máxima:", VACIA, 10, TextField.DECIMAL);
        maxTextField.setConstraints((maxTextField.getConstraints() & TextField.CONSTRAINT_MASK) | TextField.UNEDITABLE);
        minTextField = new TextField("Mínima:", VACIA, 10, TextField.DECIMAL);
        minTextField.setConstraints((minTextField.getConstraints() & TextField.CONSTRAINT_MASK) | TextField.UNEDITABLE);
        promedioTextField = new TextField("Promedio:", VACIA, 10, TextField.DECIMAL);
        promedioTextField.setConstraints((promedioTextField.getConstraints() & TextField.CONSTRAINT_MASK) | TextField.UNEDITABLE);
        aprobadosTextField = new TextField("Aprobados:", VACIA, 10, TextField.DECIMAL);
        aprobadosTextField.setConstraints((aprobadosTextField.getConstraints() & TextField.CONSTRAINT_MASK) | TextField.UNEDITABLE);
        reprobadosTextField = new TextField("Reprobados:", VACIA, 10, TextField.DECIMAL);
        reprobadosTextField.setConstraints((reprobadosTextField.getConstraints() & TextField.CONSTRAINT_MASK) | TextField.UNEDITABLE);

        cancelar = new Command(CANCELAR, Command.CANCEL, 0);
        agregar = new Command(AGREGAR, Command.SCREEN, 1);
        calcular = new Command(CALCULAR, Command.SCREEN, 2);
        
        display = Display.getDisplay(this);
        form.append(notaTextField);
        form.append(maxTextField);
        form.append(minTextField);
        form.append(promedioTextField);
        form.append(aprobadosTextField);
        form.append(reprobadosTextField);
        form.addCommand(cancelar);
        form.addCommand(agregar);
        form.addCommand(calcular);
        form.setCommandListener(this);
        display.setCurrent(form);

    }

    public void pauseApp() {
    }

    public void destroyApp(boolean unconditional) {
    }

    public void commandAction(Command c, Displayable d) {
        String label = c.getLabel();
        if (CALCULAR.equals(label)) {
            calcular();
        } else if (AGREGAR.equals(label)) {
            String nota = notaTextField.getString();
            if(VACIA.equals(nota)) {
            Alert error = new Alert("Error", "Captura la nota", null, AlertType.ERROR);
            error.setTimeout(Alert.FOREVER);
            display.setCurrent(error, form);
            }else {
            notas.addElement(nota);
            notaTextField.setString(VACIA);
            }
        } else if (CANCELAR.equals(label)) {

        }

    }

    private void calcular() {

        if (0 == notas.size()) {
            Alert error = new Alert("Error", "Primero captura algunas notas", null, AlertType.ERROR);
            error.setTimeout(Alert.FOREVER);
            display.setCurrent(error, form);
        } else {
            float maxima = 0f;
            float minima = 0f;
            float promedio = 0f;
            int aprobados = 0;
            int reprobados = 0;
            int longitud = notas.size();
            float elemento = 0f;
            String nota = (String) notas.firstElement();
            elemento = Float.parseFloat(nota);
            maxima = elemento;
            minima = elemento;

            for (int i = 0; i < longitud; i++) {
                nota = (String) notas.elementAt(i);
                elemento = Float.parseFloat(nota);
                if (elemento > maxima) {
                    maxima = elemento;
                }
                if (elemento < minima) {
                    maxima = elemento;
                }
                if (REPROBATORIA > elemento) {
                    reprobados++;
                } else {
                    aprobados++;
                }

                promedio += elemento;

            }

            promedio /= longitud;

            maxTextField.setString(Float.toString(maxima));
            minTextField.setString(Float.toString(minima));
            promedioTextField.setString(Float.toString(promedio));
            aprobadosTextField.setString(Float.toString(aprobados));
            reprobadosTextField.setString(Float.toString(reprobados));
            
        }

    }

}
